# 条件渲染

### v-if

v-if 指令用于条件性的渲染一块内容。这块内容只会在指令的表达式返回true值的时候被渲染

```
<h1 v-if="show">条件符合</h1>
//show的值转化后为true的时候显示条件符合
```

```
var app = new Vue({
  el: '#app',
  data: {
   	show:true
  }
  //data属性就是用来绑定数据到HTML的
})
```



### v-else

也可以用v-else 添加一个"else"块 用来显示条件不符合时展示的内容

```
<h1 v-else="show">条件不符合</h1>
```

```
var app = new Vue({
  el: '#app',
  data: {
   	show:false
  }
})
```



### v-else-if

`v-else-if`，顾名思义，充当 `v-if` 的“else-if 块”，可以连续使用

```
<div v-if="type === 'A'">
  A
</div>
<div v-else-if="type === 'B'">
  B
</div>
<div v-else-if="type === 'C'">
  C
</div>
<div v-else>
  Not A/B/C
</div>
```





# v-show

v-show 也适用于根据条件展示元素  用法跟v-if基本一样  

但是v-show不支持template元素 也不支持v-else, v-else-if

```
<h1 v-show="ok">Hello!</h1>
```

不同的是带有 `v-show` 的元素始终会被渲染并保留在 DOM 中。`v-show` 只是简单地切换元素的 CSS property `display`。

### v-show vs v-if

v-if  只有在条件计算后值为true时，元素才会被渲染

v-show 是不管条件为true还是false 元素总会被渲染 只是 如果条件为false 元素就会被附上display:none 从而隐藏



> 引自官方：
>
> `v-if` 是“真正”的条件渲染，因为它会确保在切换过程中条件块内的事件监听器和子组件适当地被销毁和重建。
>
> `v-if` 也是**惰性的**：如果在初始渲染时条件为假，则什么也不做——直到条件第一次变为真时，才会开始渲染条件块。
>
> 相比之下，`v-show` 就简单得多——不管初始条件是什么，元素总是会被渲染，并且只是简单地基于 CSS 进行切换。
>
> 一般来说，`v-if` 有更高的切换开销，而 `v-show` 有更高的初始渲染开销。因此，如果需要非常频繁地切换，则使用 `v-show` 较好；如果在运行时条件很少改变，则使用 `v-if` 较好。